# -----------------------------------------------------------------------------
#  Perl: 㭪樨  ஢ ᪨ ᫥
# -----------------------------------------------------------------------------

package Math::Geometry;  # ⠫ Math, 䠩 Geometry.pm

use strict;
use warnings;

BEGIN
{
  use Exporter   ();
  our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);

  # ⠭  ᨨ
  $VERSION     = 1.00;
  #  ப     ᯮ짮
  # ⥬ ࠢ ﬨ (RCS/CVS)
  $VERSION = sprintf "%d.%03d", q$Revision: 1.1 $ =~ /(\d+)/g;

  @ISA         = qw( Exporter );

  # ᯮ㥬 㭪樨  (),
  #  ᯮ  㬮砭
  # .  ,   稫   ᨢ ⮫쪮
  #               㭪樨: circle_area  circle_len.  ᤥ
  #              祡-⮤᪨ 楫.
  @EXPORT      = qw( &func1 &func2 &func4 
                     &circle_area &circle_len );
  %EXPORT_TAGS = ();     # ਬ: TAG => [ qw!name1 name2! ],

  # ᯮ㥬  ६  ()
  #  㭪樨,   ᯮ  㬮砭
  # .  ,   稫   ᨢ ⮫쪮
  #               㭪 square_perim.  ᤥ
  #              祡-⮤᪨ 楫.
  @EXPORT_OK   = qw( $Var1 %Hashit &func3
                     &square_perim );
}
our @EXPORT_OK;

# ᯮ㥬  ६   ()
our $Var1;
our %Hashit;

# ᯮ㥬  ६   ()
our @more;
our $stuff;

# ᭠砫 樠㥬 ᯮ㥬  ६  ()
$Var1   = '3';
%Hashit = ();

# ⥬ 樠㥬 ⠫  ६  ()
# .  ६ 㯭    ଥ, ਬ,
#             $Math::Geometry::stuff,    $stuff.
$stuff  = '4';
@more   = ();

#  ᪨ ६,    ࠭祭
#  䠩,   ᮧ ०, 祬 ᮧ 㭪樨,
# ᯮ騥  ६

#  ᪨ ६,   । ⮣ 䠩
my $priv_var    = '2';
my %secret_hash = ();

#  ࠧ 㭪樨,   । ⮣ 䠩
# 뢠 ⠪ 㭪樨 ⠪: &$priv_func;
# ⠪ 㭪樨    ⨯
my $priv_func = sub {
    # ⥪ 㭪樨
};

#  ᯮ  ⠫ 㭪樨,  ᯮ㥬,
# ⠪  ᯮ㥬
# .    - ᫥ ⥪
#              ᪮ {}.
sub func1      {}    # 㭪  ⨯
sub func2()    {}    # ⨯ 㪠뢠  ⢨ ࠬ஢
sub func3($$)  {}    # ⨯ 㪠뢠  稥  ᪠ ࠬ஢
sub func4(\%)  {}    # ⨯ 㪠뢠  稥 ࠬ --
                     # 뫪  -ᨢ

END { }       # , 믮騩  襭 ࠡ 
              # ( )


#  ᯮ  ணࠬ 
# ========================================

# ----------------------------------------------------------------------------
# 㭪樨  ࠡ  㣮  㦭
# ----------------------------------------------------------------------------

use constant   PI => 3.14159265;

# ---------------------------
# ᫥ 頤 㣠
# ---------------------------
sub circle_area( $$ )
{
  # ࠬ - ࠤ 㦭  ਧ 뢮   ࠭
  my $rad = shift;
  my $formula = shift;

  my $area;

  # 頤 ࠢ:  * ࠤ  
  $area = PI * $rad * $rad;
  
  if ( $formula )
  {
    print "㫠   頤 㣠: \n" .
          "---  * ࠤ   ---\n";
  }
  
  return ( $area );  # ⪠ : return ( PI * $rad * $rad );
}

# -------------------------------
# ᫥  㦭
# -------------------------------
sub circle_len( $$ )
{
  # ࠬ - ࠤ 㦭  ਧ 뢮   ࠭
  my $rad = shift;
  my $formula = shift;

  my $len;

  #  㦭 ࠢ: 2 *  * ࠤ
  $len = 2 * PI * $rad;

  if ( $formula )
  {
    print "㫠    㦭: \n" .
          "--- 2 *  * ࠤ ---\n";
  }
  
  return ( $len );
}


# ----------------------------------------------------------------------------
# 㭪樨  ࠡ  ⮬
# ----------------------------------------------------------------------------

# -----------------------------
# ᫥ 頤 
# -----------------------------
sub square_area( $$ )
{
  # ࠬ - ஭   ਧ 뢮   ࠭
  my $side = shift;
  my $formula = shift;

  my $area;
  
  # 頤 ࠢ:  ஭  
  $area = $side * $side;

  if ( $formula )
  {
    print "㫠   頤 : \n" .
          "---  ஭   ---\n";
  }

  return ( $area );
}

#----------------------------------
# ᫥ ਬ 
# ---------------------------------
sub square_perim( $$ )
{
  # ࠬ - ஭   ਧ 뢮   ࠭
  my $side = shift;
  my $formula = shift;

  my $len;

  # ਬ ࠢ: 4 *  ஭
  $len = 4 * $side;

  if ( $formula )
  {
    print "㫠   ਬ : \n" .
          "---  ஭ * 4 ---\n";
  }

  return ( $len );
}


1;  #  頥 祭 "⨭" ( ⢮ 易⥫쭮)
