// ----------------------------------------------------------------------------
// ணࠬ,  ᯮ짮 ᪮ 㧪
// ࠧ塞 ⥪  ।  Windows
// ----------------------------------------------------------------------------

#include <stdio.h>
#include <windows.h>

//    䠩 ⥯ 㦥  㦭, . .  樨
// ணࠬ 㭪樨  ⥪  㯭
// #include "geometry2.h"

#define  PRINT_FORMULA  1

// । 㪠⥫  㭪, ਭ  ࠬ
//   祭 ⨯ float (⠪  㭪樨  襩 ⥪)
typedef float ( *library_func )( float, int );

// ⨯ 㭪樨 get_func()
library_func get_func( void *dll_lib_handle, const char *func_name );

int main( void )
{
  float rad;
  float side;

  HINSTANCE dll_lib;     // ਯ 㦠 ⥪ DLL
  library_func lib_fn;   // 㪠⥫  㭪  ⥪ DLL
  
  // 뢠 ⥪ DLL
  dll_lib = LoadLibrary( "libgeometry2.dll" );
  if ( dll_lib == NULL )
  {
    fprintf( stderr, "   ⥪ libgeometry2.dll\n" );
    exit( 1 );
  }                 

  printf( "᪠ 㧪 ⥪ DLL\n\n" );

  printf( " ࠤ 㦭: " );
  scanf( "%f", &rad );
  printf( "\n%f\n", rad );

  // ᫨ 㤠  㪠⥫  㭪 circle_len,
  //  믮 
  // . 뢠  㭪, ᯮ 㪠⥫  .
  if ( ( lib_fn = get_func( dll_lib, "circle_len" ) ) != NULL )
    printf( " 㦭: %f\n", ( *lib_fn )( rad, PRINT_FORMULA ) );
  
  // 砥   ⠫ 㭪  ⥪ 筮
  if ( ( lib_fn = get_func( dll_lib, "circle_area" ) ) != NULL )
    printf( "頤 㣠: %f\n", ( *lib_fn )( rad, PRINT_FORMULA ) );

  printf( "\n  ஭ : " );
  scanf( "%f", &side );
  printf( "\n%f\n", side );

  if ( ( lib_fn = get_func( dll_lib, "square_perim" ) ) != NULL )
    printf( "ਬ : %f\n", ( *lib_fn )( side, PRINT_FORMULA ) );

  if ( ( lib_fn = get_func( dll_lib, "square_area" ) ) != NULL )
    printf( "頤 : %f\n", ( *lib_fn )( side, PRINT_FORMULA ) );
  
  // 뢠 ⥪ DLL
  FreeLibrary( dll_lib );

  return 0;
}

library_func get_func( void *lib_handle, const char *func_name )
{
  // lib_handle - ਯ 㦠 ⥪ DLL
  // func_name -  㭪樨  ⥪ DLL

  library_func lib_func; // 㪠⥫  㭪  ⥪ DLL

  // 稬  筮 㭪樨
  // .  ॡ  ਢ ⨯.
  lib_func = ( library_func )GetProcAddress( lib_handle, func_name );

  if ( ( lib_func == NULL ) )
  {
    fprintf( stderr, "   %s\n", func_name );
    // exit( 1 );  //   室    ணࠬ
    return NULL;
  }

  return lib_func;
}
